import checkIfIsMaster from "../../../utils/check-if-is-master";
import connDbHandler from "../../../utils/db/conn-db-handler";
/**
 * # Delete DB Entry Function
 * @description
 */
export default async function deleteDbEntry({ dbContext, dbFullName, tableName, identifierColumnName, identifierValue, forceLocal, }) {
    var _a;
    try {
        const isMaster = forceLocal
            ? true
            : checkIfIsMaster({ dbContext, dbFullName });
        const DB_CONN = isMaster
            ? global.DSQL_DB_CONN
            : global.DSQL_FULL_ACCESS_DB_CONN || global.DSQL_DB_CONN;
        /**
         * Execution
         *
         * @description
         */
        const query = `DELETE FROM ${isMaster && !dbFullName ? "" : `\`${dbFullName}\`.`}\`${tableName}\` WHERE \`${identifierColumnName.toString()}\`=?`;
        const deletedEntry = await connDbHandler(DB_CONN, query, [
            identifierValue,
        ]);
        /**
         * Return statement
         */
        return deletedEntry;
    }
    catch (error) {
        (_a = global.ERROR_CALLBACK) === null || _a === void 0 ? void 0 : _a.call(global, `Error Deleting Entry`, error);
        return null;
    }
}
