import { UserSQLPermissions, } from "../../../types";
import grabDbFullName from "../../../utils/grab-db-full-name";
import dbHandler from "../../backend/dbHandler";
import normalizeText from "../../../utils/normalize-text";
export default async function handleMariadbUserGrantsForDatabasesRecreateGrants({ currentAccessedDatabase, user, updatedRecord, }) {
    const { accessedDatabase, dbSlug, allGrants, allTables, grants, tables } = currentAccessedDatabase;
    const dbFullName = grabDbFullName({
        user,
        dbName: dbSlug,
    });
    if (allGrants && allTables) {
        const grantAllPrivileges = await dbHandler({
            query: normalizeText(`
                    GRANT ALL PRIVILEGES ON \`${dbFullName}\`.* TO \
                    '${updatedRecord.username}'@'${updatedRecord.host}'
                `),
        });
        return { success: true };
    }
    if (allGrants && (tables === null || tables === void 0 ? void 0 : tables[0])) {
        for (let t = 0; t < tables.length; t++) {
            const table = tables[t];
            // queries.push(
            //     normalizeText(`
            //             GRANT ALL PRIVILEGES ON \`${dbFullName}\`.\`${table.tableSlug}\` \
            //             TO '${updatedRecord.username}'@'${updatedRecord.host}'
            //         `)
            // );
            const grantAllPrivilegesToTables = await dbHandler({
                query: normalizeText(`
                    GRANT ALL PRIVILEGES ON \`${dbFullName}\`.\`${table.tableSlug}\` \
                    TO '${updatedRecord.username}'@'${updatedRecord.host}'
                `),
            });
        }
        return { success: true };
    }
    if (grants === null || grants === void 0 ? void 0 : grants[0]) {
        const isGrantsInalid = grants.find((g) => !UserSQLPermissions.includes(g));
        if (isGrantsInalid) {
            return { msg: `grants is/are invalid!` };
        }
        if (tables === null || tables === void 0 ? void 0 : tables[0]) {
            for (let t = 0; t < tables.length; t++) {
                const table = tables[t];
                const grantSpecificPrivilegesToTables = await dbHandler({
                    query: normalizeText(`
                        GRANT ${grants.join(",")} ON \
                        \`${dbFullName}\`.\`${table.tableSlug}\` TO \
                        '${updatedRecord.username}'@'${updatedRecord.host}'
                    `),
                });
            }
            return { success: true };
        }
        else {
            const grantSecificPrivilegesToAllTables = await dbHandler({
                query: normalizeText(`
                    GRANT ${grants.join(",")} ON \
                    \`${dbFullName}\`.* TO \
                    '${updatedRecord.username}'@'${updatedRecord.host}'
                    `),
            });
            return { success: true };
        }
    }
    return { success: true };
}
