import connDbHandler from "../../db/conn-db-handler";
import grabDSQLConnection from "../../grab-dsql-connection";
/**
 * # DSQL user read-only DB handler
 */
export default async function DSQL_USER_DB_HANDLER({ paradigm, queryString, queryValues, }) {
    var _a;
    const CONNECTION = paradigm == "Read Only"
        ? grabDSQLConnection({ ro: true })
        : grabDSQLConnection({ fa: true });
    try {
        return await connDbHandler(CONNECTION, queryString, queryValues);
    }
    catch (error) {
        (_a = global.ERROR_CALLBACK) === null || _a === void 0 ? void 0 : _a.call(global, `DSQL_USER_DB_HANDLER Error`, error);
        return null;
    }
    finally {
        CONNECTION === null || CONNECTION === void 0 ? void 0 : CONNECTION.end();
    }
}
