import numberfy from "../../numberfy";
export const DataTypesWithNumbers = [
    "DECIMAL",
    "DOUBLE",
    "FLOAT",
    "VARCHAR",
];
export const DataTypesWithTwoNumbers = [
    "DECIMAL",
    "DOUBLE",
    "FLOAT",
];
export default function dataTypeParser(dataType) {
    if (!dataType) {
        return {
            type: "VARCHAR",
            limit: 250,
        };
    }
    const dataTypeArray = dataType.split("(");
    const type = dataTypeArray[0];
    const number = dataTypeArray[1];
    if (!DataTypesWithNumbers.includes(type)) {
        return {
            type,
        };
    }
    if (number === null || number === void 0 ? void 0 : number.match(/,/)) {
        const numberArr = number.split(",");
        return {
            type,
            limit: numberfy(numberArr[0]),
            decimal: numberArr[1] ? numberfy(numberArr[1]) : undefined,
        };
    }
    return {
        type,
        limit: number ? numberfy(number) : undefined,
    };
}
