import mysql from "serverless-mysql";
/**
 * # Grab General CONNECTION for DSQL
 */
export default function grabDSQLConnection(param) {
    if (global.DSQL_USE_LOCAL || (param === null || param === void 0 ? void 0 : param.local)) {
        return (global.DSQL_DB_CONN ||
            mysql({
                config: {
                    host: process.env.DSQL_DB_HOST,
                    user: process.env.DSQL_DB_USERNAME,
                    password: process.env.DSQL_DB_PASSWORD,
                    database: (param === null || param === void 0 ? void 0 : param.noDb)
                        ? undefined
                        : process.env.DSQL_DB_NAME,
                    port: process.env.DSQL_DB_PORT
                        ? Number(process.env.DSQL_DB_PORT)
                        : undefined,
                    charset: "utf8mb4",
                },
            }));
    }
    if (param === null || param === void 0 ? void 0 : param.ro) {
        return (global.DSQL_READ_ONLY_DB_CONN ||
            mysql({
                config: {
                    host: process.env.DSQL_DB_HOST,
                    user: process.env.DSQL_DB_READ_ONLY_USERNAME,
                    password: process.env.DSQL_DB_READ_ONLY_PASSWORD,
                    port: process.env.DSQL_DB_PORT
                        ? Number(process.env.DSQL_DB_PORT)
                        : undefined,
                    charset: "utf8mb4",
                },
            }));
    }
    if (param === null || param === void 0 ? void 0 : param.fa) {
        return (global.DSQL_FULL_ACCESS_DB_CONN ||
            mysql({
                config: {
                    host: process.env.DSQL_DB_HOST,
                    user: process.env.DSQL_DB_FULL_ACCESS_USERNAME,
                    password: process.env.DSQL_DB_FULL_ACCESS_PASSWORD,
                    port: process.env.DSQL_DB_PORT
                        ? Number(process.env.DSQL_DB_PORT)
                        : undefined,
                    charset: "utf8mb4",
                },
            }));
    }
    return (global.DSQL_DB_CONN ||
        mysql({
            config: {
                host: process.env.DSQL_DB_HOST,
                user: process.env.DSQL_DB_USERNAME,
                password: process.env.DSQL_DB_PASSWORD,
                database: (param === null || param === void 0 ? void 0 : param.noDb) ? undefined : process.env.DSQL_DB_NAME,
                port: process.env.DSQL_DB_PORT
                    ? Number(process.env.DSQL_DB_PORT)
                    : undefined,
                charset: "utf8mb4",
            },
        }));
}
